(*!
* @file        Ima/Ima.st
* @brief       AsIMAͨŰ
* @date        ڣ2022.08.27
* @author      MuShanshan
* @copyright   B&R
*)
(*! History
 *****************************************************************************
 *     2012.08.27    V1.00.1   MuShanshan
 *         (new)     ʵֻ
 *     2022.08.15    V1.00.2   YuanZhiyi
 *         (new)     ߺ޷ָͨѶ
 ******************************************************************************
*)

PROGRAM _INIT
	fRTInfo.enable := 1;
	fRTInfo();
	cycT := fRTInfo.cycle_time/1000;	//ms	
	
	gImaCtrl.monitor.statusInit := IMAinit(ADR(IMA_DATA_MODULE_NAME), gImaCtrl.monitor.infoInit, ADR(imaIdent));

	commStep := STEP_WAIT;
	IF(gImaCtrl.monitor.statusInit = 0) THEN
		initOK := 1;     //ʼɹ
	ELSE
		initOK := 0;    //*ʼʧ߲ܶʡԴ
	END_IF
		
END_PROGRAM


PROGRAM _CYCLIC

	(*IMA communication*)
	IF ((gImaCtrl.monitor.statusInit = 0) AND (gImaCtrl.cmd.restart = 0)) THEN 
		gImaCtrl.monitor.statusComm := IMAcomm(imaIdent, gImaCtrl.monitor.infoCommPV, gImaCtrl.monitor.infoCommAUX);
		commStep := STEP_WAIT;	
	END_IF
	
	(*cmd restart*)
	IF((gImaCtrl.monitor.statusComm <> 0) AND (initOK = 1)) THEN
		restartCont := restartCont + cycT;
		IF (restartCont >= IMA_RESTART_DELAY) THEN
			gImaCtrl.cmd.restart := 1;   
		END_IF
	ELSE 
		restartCont := 0;
	END_IF
			
			
	(* IMA߿ *)
	CASE commStep OF
		STEP_WAIT:
			IF(gImaCtrl.cmd.restart = 1) THEN
				commStep    := STEP_CLOSE;
			END_IF
	

		STEP_CLOSE:
			IF imaIdent = 0 THEN
				commStep := STEP_INIT;	
			ELSE
				gImaCtrl.monitor.statusClose := IMAclose(imaIdent);				
				IF gImaCtrl.monitor.statusClose = 0 THEN
					commStep := STEP_INIT;	
				END_IF
			END_IF
		
		STEP_INIT:		
			gImaCtrl.monitor.statusInit := IMAinit(ADR(IMA_DATA_MODULE_NAME), gImaCtrl.monitor.infoInit, ADR(imaIdent));
			IF (gImaCtrl.monitor.statusInit = 0) THEN 
				gImaCtrl.cmd.restart := 0;
				commStep := STEP_WAIT;
			END_IF
	END_CASE
			
				
	(* ʾIMAͨ״̬ͼ *)
	IF(initOK = 0) THEN                 //init error
		gImaCtrl.monitor.visIMABmpIndex := 10;
	ELSIF (gImaCtrl.monitor.statusComm <> IMA_OK) THEN //communication error
		visIMAStatusCont := UDINT_TO_UINT(visIMAStatusCont + cycT);
		IF(visIMAStatusCont > 200) THEN //[ms] change communication bmp on vis
			visIMAStatusCont := 0;
			gImaCtrl.monitor.visIMABmpIndex := gImaCtrl.monitor.visIMABmpIndex + 1;
		END_IF
	
		IF (gImaCtrl.monitor.visIMABmpIndex > 10)  THEN   //ͼ1-10
			gImaCtrl.monitor.visIMABmpIndex := 1;
		END_IF
	ELSE
		gImaCtrl.monitor.visIMABmpIndex := 0;  
	END_IF
			
END_PROGRAM
