(********************************************************************
 * COPYRIGHT -- B&R China
 ********************************************************************
 * Program: TimeVis
 * File: TimeVis.st
 * Author: mus
 * Created: August 27, 2012
 ********************************************************************
 * Implementation of program TimeVis
 ********************************************************************)

PROGRAM _INIT

	(*Variable declare*)
	gActPic := gActPic;
	gSetPic := gSetPic;
	fRTInfo.enable := 1;
	fRTInfo();
	cycT := fRTInfo.cycle_time/1000;	//ms	

END_PROGRAM


PROGRAM _CYCLIC

	CASE stepSetTime OF
		0://wait command
			IF(setTimeVis = 1) THEN
				setTimeVis      := 0;        
				setTimeCpu     := 1;       	 //Set cpu time
				errorSetCpuTime := 0;        //Clear error
				stepSetTime     := 10;      	 //Set vis time
			ELSE
				(*time init*)
				IF(gTimeInit = 0) THEN          //ima read time 
					IF(getTime.year <> 0 AND getTime.millisec <> 0) THEN 	//get time from cp1486
						IF (RTC_settime(ADR(getTime)) = 0) THEN	
							gTimeInit := 1;
						END_IF
						
						setTime.year     := getTime.year;
						setTime.month    := getTime.month;
						setTime.day      := getTime.day;
						setTime.hour     := getTime.hour;
						setTime.minute   := getTime.minute;
						setTime.second   := getTime.second;									
					END_IF
				END_IF //if(timeInit = 0)			
			END_IF //IF(setTimeVis = 1)
			setTimeCont := 0;   		
			
		10:	//set vis time
			IF (RTC_settime(ADR(setTime)) = 0)	THEN
				stepSetTime := 20;
			END_IF
			
		20:    //wait cpu finished set time
			IF(setTimeCpu = 0) THEN     //cpu set time finish
				stepSetTime := 0;      //wait command
			END_IF
			
			setTimeCont := UDINT_TO_UINT(setTimeCont + cycT);
			IF(setTimeCont > 5000) THEN //5s
				setTimeCont := 0;
				stepSetTime := 0;
				setTimeCpu  := 0;
				errorSetCpuTime := 1;
			END_IF
			
	END_CASE
	
			
END_PROGRAM
